WebApp/Controllers/MainController.cs
using System;
using System.Collections.Generic;
using System.Web.Mvc;
using WebApp.ViewModels;
using AutoMapper;
using WebApp.BLL.DTO;
using WebApp.BLL.Infrastructure;
using WebApp.BLL.Services;

namespace WebApp.Controllers
{
    public class MainController : Controller
    {
        private TrainService TrainService { get; set; }

        public ActionResult Index()
        {
            var stationDTOs = TrainService.GetStations();
            var stationsFrom = new List<SelectListItem>();
            var stationsTo = new List<SelectListItem>();

            foreach (var station in stationDTOs)
            {
                stationsFrom.Add(new SelectListItem {Text = station.Title, Value = station.Title});
                stationsTo.Add(new SelectListItem {Text = station.Title, Value = station.Title});
            }

            var stations = new StationsViewModel()
            {
                StationFrom = new StationViewModel(),
                StationTo = new StationViewModel(),
                StationsFrom = stationsFrom,
                StationsTo = stationsTo,
                Date = DateTime.UtcNow
            };

            return View(stations);
        }

        [HttpPost]
        public ActionResult Find(StationsViewModel stations)
        {
            if (stations.StationFrom.Title == stations.StationTo.Title)
            {
                ModelState.AddModelError("", @"Stations must be different.");
            }
            
            if (!ModelState.IsValid)
            {
                var stationDTOs = TrainService.GetStations();
                var stationsFrom = new List<SelectListItem>();
                var stationsTo = new List<SelectListItem>();

                foreach (var station in stationDTOs)
                {
                    stationsFrom.Add(new SelectListItem {Text = station.Title, Value = station.Title});
                    stationsTo.Add(new SelectListItem {Text = station.Title, Value = station.Title});
                }

                stations.StationsFrom = stationsFrom;
                stations.StationsTo = stationsTo;

                return View("Index", stations);
            }

            return RedirectToAction("Trains", new
            {
                stationFrom = stations.StationFrom.Title,
                stationTo = stations.StationTo.Title,
                date = stations.Date.ToShortDateString()
            });
        }
        [HttpGet]
        public ActionResult Trains(string stationFrom, string stationTo, string date)
        {
            var stations = new StationsViewModel()
            {
                StationFrom = new StationViewModel() {Title = stationFrom},
                StationTo = new StationViewModel() {Title = stationTo},
                Date = DateTime.Parse(date)
            };

            Mapper.Initialize(cfg => cfg.CreateMap<StationViewModel, StationDTO>());

            var stFrom = Mapper.Map<StationViewModel, StationDTO>(stations.StationFrom);
            var stTo = Mapper.Map<StationViewModel, StationDTO>(stations.StationTo);

            var stationsDto = new StationsDTO()
            {
                Date = stations.Date,
                StationFrom = stFrom,
                StationTo = stTo
            };

            var config = new MapperConfiguration(cfg =>
            {
                cfg.CreateMap<TripDTO, TripViewModel>();
                cfg.CreateMap<StationInfoDTO, StationInfoViewModel>();
            });

            config.AssertConfigurationIsValid();

            var mapper = config.CreateMapper();
            var tripsDTO = new List<TripDTO>();
            var tripsViewModel = new List<TripViewModel>();

            try
            {
                tripsDTO = TrainService.Find(stationsDto);
                tripsViewModel = mapper.Map<List<TripDTO>, List<TripViewModel>>(tripsDTO);
            }
            catch (ValidationException e)
            {
                ModelState.AddModelError(e.Property, e.Message);
                return View(tripsViewModel);
            }

            return View(tripsViewModel);
        }

        public MainController()
        {
            this.TrainService = new TrainService();
        }
    }
}

WebApp/Controllers/TicketController.cs
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using WebApp.BLL.Services;
using WebApp.ViewModels;
using AutoMapper;
using WebApp.BLL.DTO;
using WebApp.BLL.Infrastructure;


namespace WebApp.Controllers
{
    [Authorize]
    public class TicketController : Controller
    {
        private TicketService TicketService { get; set; }
        private TrainService TrainService { get; set; }

        [HttpGet]
        public ActionResult Buy(int tripId, double cost, string stationboarding, string stationarriving, string arrivingdate, string boardingdate, TimeSpan timeinroute, string error, int? userdiscount)
        {
            var train = TrainService.GetTrainByTripId(tripId);
            var mapper = new MapperConfiguration(t => t.CreateMap<CarriageDTO, CarriageViewModel>()).CreateMapper();
            var carriages = mapper.Map<List<CarriageViewModel>>(TicketService.GetCarriages(train.Id));
            var carriagesSelectList = new SelectList(carriages, "Id", "Number");

            if (userdiscount == null)
            {
                userdiscount = 0;
            }

            if (User.IsInRole("special"))
            {
                userdiscount = (int) cost / 2;
            }
            
            var ticketViewModel = new TicketViewModel();
            if (error?.Length > 0)
            {
                ModelState.AddModelError("", error);
            }
            ticketViewModel.TripId = tripId;
            ticketViewModel.Carriages = carriagesSelectList;
            ticketViewModel.TrainId = train.Id;
            ticketViewModel.TrainTitle = train.Title;
            ticketViewModel.CarriageId = 1;
            ticketViewModel.Cost = cost;
            ticketViewModel.userdiscount = (int) userdiscount;
            ticketViewModel.stationboarding = stationboarding;
            ticketViewModel.stationarriving = stationarriving;
            ticketViewModel.arrivingdate = DateTime.Parse(arrivingdate, CultureInfo.GetCultureInfo("ru-RU"));
            ticketViewModel.boardingdate = DateTime.Parse(boardingdate, CultureInfo.GetCultureInfo("ru-RU"));
            ticketViewModel.timeinroute = timeinroute;

            return View(ticketViewModel);
        }
        [HttpPost]
        [ActionName("Buy")]
        public ActionResult Buy(OrderViewModel orderViewModel)
        {
            if (!ModelState.IsValid)
            {
                return RedirectToAction("Buy", new {
                    tripId = orderViewModel.TripId,
                    cost = orderViewModel.Cost,
                    userdiscount = orderViewModel.userdiscount,
                    stationboarding = orderViewModel.stationboarding,
                    stationarriving = orderViewModel.stationarriving,
                    arrivingdate = orderViewModel.arrivingdate.ToString("dd/MM/yyyy HH:mm:ss"),
                    boardingdate = orderViewModel.boardingdate.ToString("dd/MM/yyyy HH:mm:ss"),
                    timeinroute = orderViewModel.timeinroute,
                    error = "Invalid values."
                });
            }

            var mapper = new MapperConfiguration(t => t.CreateMap<OrderViewModel, OrderDTO>()).CreateMapper();
            var orderDTO = mapper.Map<OrderDTO>(orderViewModel);
            orderDTO.UserName = User.Identity.Name;
            var ticketInfoId = 0;

            try
            {
                ticketInfoId = TicketService.Buy(orderDTO);
            }
            catch (ValidationException e)
            {
                ModelState.AddModelError(e.Property, e.Message);
                return RedirectToAction("Buy", new
                {
                    tripId = orderViewModel.TripId,
                    cost = orderViewModel.Cost,
                    userdiscount = orderViewModel.userdiscount,
                    stationboarding = orderViewModel.stationboarding,
                    stationarriving = orderViewModel.stationarriving,
                    arrivingdate = orderViewModel.arrivingdate.ToString("dd/MM/yyyy HH:mm:ss"),
                    boardingdate = orderViewModel.boardingdate.ToString("dd/MM/yyyy HH:mm:ss"),
                    timeinroute = orderViewModel.timeinroute,
                    error = e.Message
                });
            }
            catch (BankException b)
            {
                ModelState.AddModelError("", b.Message);
                return RedirectToAction("Buy", new
                {
                    tripId = orderViewModel.TripId,
                    cost = orderViewModel.Cost,
                    userdiscount = orderViewModel.userdiscount,
                    stationboarding = orderViewModel.stationboarding,
                    stationarriving = orderViewModel.stationarriving,
                    arrivingdate = orderViewModel.arrivingdate.ToString("dd/MM/yyyy HH:mm:ss"),
                    boardingdate = orderViewModel.boardingdate.ToString("dd/MM/yyyy HH:mm:ss"),
                    timeinroute = orderViewModel.timeinroute,
                    error = b.Message
                });
            }
            
            return RedirectToAction("Get", new { id = ticketInfoId });
        }

        public ActionResult Get(int id)
        {
            var ticketInfoDTO = TicketService.GetTicket(id);
            var mapper = new MapperConfiguration(t => t.CreateMap<TicketInfoDTO, OrderedTicketViewModel>()).CreateMapper();
            var orderedTicketViewModel = mapper.Map<OrderedTicketViewModel>(ticketInfoDTO);

            return View(orderedTicketViewModel);
        }

        public ActionResult Tickets()
        {
            var ticketInfoDTOs = TicketService.GetTickets(User.Identity.Name);
            var mapper = new MapperConfiguration(t => t.CreateMap<TicketInfoDTO, OrderedTicketViewModel>()).CreateMapper();
            var orderedTicketViewModels = mapper.Map<List<OrderedTicketViewModel>>(ticketInfoDTOs);

            return View(orderedTicketViewModels);
        }

        [HttpPost]
        public ActionResult GetSeats(int id)
        {
            var seats = new SelectList(TicketService.GetSeats(id), "Id", "Number");

            return PartialView("PartialSeats", seats);
        }

        public TicketController()
        {
            this.TicketService = new TicketService();
            this.TrainService = new TrainService();
        }
    }
}

WebApp/Views/Main/Index.cshtml
@model WebApp.ViewModels.StationsViewModel

@{
    ViewBag.Title = "Home Page";
}

@using (Html.BeginForm("Find", "Main", FormMethod.Post, new { @class = "form-horizontal" }))
{
    @Html.ValidationSummary(false)

    <div class="form-group">
        @Html.Label("Boarding station:", new { @class = "col-sm-2 control-label" })
        <div class="col-sm-10">
            @Html.DropDownListFor(t => t.StationFrom.Title, Model.StationsFrom, new { @class = "form-control", required = "required" })
        </div>
    </div>
    <div class="form-group">
        @Html.Label("Arriving station:", new { @class = "col-sm-2 control-label" })
        <div class="col-sm-10">
            @Html.DropDownListFor(t => t.StationTo.Title, Model.StationsTo, new { @class = "form-control", required = "required" })
        </div>
    </div>
    <div class="form-group">
        @Html.Label("Boarding date:", new { @class = "col-sm-2 control-label" })
        <div class="col-sm-10">
            @Html.TextBoxFor(t => t.Date, new { @class = "form-control", required = "required", type = "date" })
        </div>
    </div>

    <div class="form-group">
        <div class="col-sm-offset-2 col-sm-10">
            <button type="submit" class="btn btn-info">Search</button>
        </div>
    </div>
    
}

WebApp/Views/Main/Trains.cshtml
@using WebApp.Models
@model List<WebApp.ViewModels.TripViewModel>

@{
    ViewBag.Title = "Trains";
}

@Html.ValidationSummary(false)

@if (Model.Count == 0)
{
    @:No trains between stations you specified.
}
else
{
    <div class="panel panel-default">
        <div class="panel-heading"><h4>Trains</h4></div>

        <table class="table">
            <thead>
            <th>Title</th>
            <th>Between stations</th>
            <th>Boarding and arriving stations</th>
            <th>Boarding and arriving dates</th>
            <th>Time in route</th>
            <th>Cost</th>
            <th>Free seats</th>
            <th>Route</th>
            </thead>
            <tbody>
            
            @foreach (var model in Model)
            {
                <tr valign="middle">
                    <td>@Html.DisplayFor(t => model.TrainTitle)</td>

                    <td>@Html.DisplayFor(t => model.StationFrom.Title) - @Html.DisplayFor(t => model.StationTo.Title)</td>

                    <td>@Html.DisplayFor(t => model.StationBoarding.Title) - @Html.DisplayFor(t => model.StationArriving.Title)</td>

                    <td>@Html.DisplayFor(t => model.DateTimeOfStart) - @Html.DisplayFor(t => model.DateTimeOfArriving)</td>

                    <td>@Html.DisplayFor(t => model.TimeInRoute)</td>

                    <td>@Html.DisplayFor(t => model.Cost)</td>

                    <td>
                        @foreach (var seatType in model.FreeSeats)
                        {
                            <span>
                                @(((WebApp.Models.SeatType) seatType.Key).ToString()):
                            </span>
                            <span>
                                @Html.DisplayFor(t => seatType.Value)
                            </span>
                            <br/>
                        }
                    </td>
                    
                    <td rowspan="1">
                        @Html.ActionLink("Buy", "Buy", "Ticket", new
                   {
                       tripId = model.TripId,
                       cost = model.Cost,
                       stationboarding = model.StationBoarding.Title,
                       stationarriving = model.StationArriving.Title,
                       arrivingdate = model.DateTimeOfArriving.ToString("dd/MM/yyyy HH:mm:ss"),
                       boardingdate = model.DateTimeOfStart.ToString("dd/MM/yyyy HH:mm:ss"),
                       timeinroute = model.TimeInRoute
                   }, new { @class = "btn btn-info" })
                    </td>
                </tr>
                <tr class="active">
                    <td colspan="8">
                        @foreach (var traverseStation in model.TraverseStations)
                        {
                            <span>
                                @Html.DisplayFor(t => traverseStation.Value.Title)
                            </span>

                            <span>
                                (@(Html.DisplayFor(t => traverseStation.Value.DateTimeOfStart)) -  
                            </span>

                            <span>
                                @(Html.DisplayFor(t => traverseStation.Value.DateTimeOfLeaving)),
                            </span>

                            <span>
                                @(Html.DisplayFor(t => traverseStation.Value.TimeOfWaiting))) |
                            </span>

                        }
                    </td>
                </tr>
            }
            </tbody>
        </table>
    </div>
}